

//form id
var form_id = 'survey';

//blocks
var blocks = jsonfile.blocks;
var blocks_count = jsonfile.blocks.length;

var random_pages = false;
var random_items = false;
var consideration_page = false;
var consideration_include_text = true;

var tracker_count = 0;

var FilenamePrefix = (jsonfile.hasOwnProperty('mandatory') && jsonfile.mandatory.hasOwnProperty('FilenamePrefix')) ? jsonfile.mandatory.FilenamePrefix : 'dynamic';
var TrialID = (jsonfile.hasOwnProperty('mandatory') && jsonfile.mandatory.hasOwnProperty('TrialID')) ? jsonfile.mandatory.TrialID : '0000';
var UIDrandom = Math.floor(Math.random() * 1000000000000000000);
var CurrentDate = new Date();
var CurrentDateMil = Date.parse(CurrentDate);
var CurrentDateFormat = CurrentDate.getFullYear() + "-"
                      + ('0' + (CurrentDate.getMonth() + 1)).slice(-2)  + "-"
                      + ('0' + CurrentDate.getDate()).slice(-2) + "T"
                      + ('0' + CurrentDate.getHours()).slice(-2) + ":"
                      + ('0' + CurrentDate.getMinutes()).slice(-2) + ":"
                      + ('0' + CurrentDate.getSeconds()).slice(-2);

                      console.log(FilenamePrefix);

//sort object
function sortObject(o) {
    var sorted = {},
    key, a = [];

    for (key in o) {
        if (o.hasOwnProperty(key)) {
            a.push(key);
        }
    }

    a.sort();

    for (key = 0; key < a.length; key++) {
        sorted[a[key]] = o[a[key]];
    }
    return sorted;
}


//parse blocks
function parseBlocks(pages, random_pages, pages_count) {

  //randomize order of pages
  if(random_pages == true ) {
      pages = pages.sort(function() {
            return .5 - Math.random();
      });
  }

  //loop through pages
  //console.log('---pages---');
  //console.log(pages);

  //for (var i = 0; i < pages_count; i++){
  $.each(pages, function(i, items) {
    var pagenumber = pages_count + i;
    var items = pages[i].items;
    var items_count = pages[i].items.length;
    var page = '<div id="p-'+ pagenumber +'" class="page"></div>';
    $('#' + form_id).find('.list').append(page);

    //console.log(items);

    for (var a = 0; a < items_count; a++){

      //console.log(items[a].type);
      var item = '<div id="item-'+items[a].id+'" class="item '+items[a].type+'" data-type="'+items[a].type+'"></div>';

      //check if is ref item -- ref item belongs to a tracker
      var ref = items[a].ref;

      if(typeof ref != "undefined") {
        //console.log('ref has ref with value ' + items[a].ref);
        item = '<div id="item-'+items[a].id+'" class="item '+items[a].type+' ref hide" data-type="'+items[a].type+'"></div>';
      }

      //add div for each item

      $('#p-'+ pagenumber).append(item);


      //add elements depending on content type

      //textinput
      if(items[a].type == 'textinput') {
        var content = '<label for="'+items[a].id+'">'+items[a].text+'</label></br>';
        var input = '<input id="'+items[a].id+'" name="'+items[a].id+'" type="text" />'
        $('#item-'+items[a].id).append(content, input);
      }

      //likert
      if(items[a].type == 'likert') {

        var quantity = '<input id="item-'+items[a].id+'-quantity" class="hide" name="'+items[a].id+'-quantity" type="text" value="'+items[a].number_selectors+'" />';
        $('#item-'+items[a].id).append(quantity);
        var likert_question = '<p>'+items[a].question+'</p>'
        var likert = '<ul class="likert-group"></ul>';
        var caption_left = '<li>'+items[a].caption_left+'</li>';
        var caption_right = '<li>'+items[a].caption_right+'</li>';
        var number_selectors = parseInt(items[a].number_selectors);

        $('#item-'+items[a].id).append(likert_question).append(likert);
        $('#item-'+items[a].id).find('.likert-group').append(caption_left);

        for(z = 0; z < number_selectors; z++) {

          var item_selector = '<li><input type="radio" name="'+items[a].id+'" value="'+z+'" /></li>';
          $('#item-'+items[a].id).find('.likert-group').append(item_selector);

        }

        $('#item-'+items[a].id).find('.likert-group').append(caption_right);

      }

      //pic
      if(items[a].type == 'pic') {
        var content = '<img src="'+items[a].url+'">';
        $('#item-'+items[a].id).append(content);
      }

      //text
      if(items[a].type == 'infotext') {
        var content = '<p>'+items[a].text+'</p>';
        $('#item-'+items[a].id).append(content);
      }

      //tracker
      if(items[a].type == 'tracker') {

        tracker_count++;

        var content = '';

        var input_xpos = '<input id="item-'+items[a].id+'-xpos" class="hide" name="'+items[a].id+'-xpos" type="text" />';
        //$('#item-'+items[a].id).append(input_xpos);
        content += input_xpos;

        var input_ypos = '<input id="item-'+items[a].id+'-ypos" class="hide" name="'+items[a].id+'-ypos" type="text" />';
        //$('#item-'+items[a].id).append(input_ypos);
        content += input_ypos;

        var trackerposition = '<input id="item-'+items[a].id+'-position" class="hide" name="'+items[a].id+'-position" type="text" value="'+tracker_count+'" />';
        //$('#item-'+items[a].id).append(trackerposition);
        content += trackerposition;

        var title = '<h2>'+items[a].title+'</h2>';
        //$('#item-'+items[a].id).prepend(title);
        content += title;

        var desc = '<input id="item-'+items[a].id+'-desc" class="hide" name="'+items[a].id+'-desc" type="text" value="'+items[a].desc+'" />';
        //$('#item-'+items[a].id).append(desc);
        content += desc;

        var trackitems = '<div class="select-items tracker-items hide"></div>';
        //$('#item-'+items[a].id).append(trackitems);
        content += trackitems;

        $('#item-'+items[a].id).append(content);

        $('#item-'+items[a].id).parent('.page').addClass('tracker-group');


        //if type img
        if(items[a].type_tracker == 'image') {

          //if true then display images in random order
          //console.log('random items');
          //console.log(items[a].random);
          random_items = items[a].random;
          if(random_items == true ) {
              items[a].items = items[a].items.sort(function() {
                    return .5 - Math.random();
              });
          }

          $.each(items[a].items, function(g, item) {
            //for(g = 0; g < items[a].items.length; g++) {
              var sub_content = '<div class="tracker-select tracker-select-'+g+' tracker-select--image" data-type="'+items[a].type_tracker+'" data-value="'+items[a].items[g]["name"]+'" data-img="'+items[a].items[g]['content']+'"><label><input type="radio" name="'+items[a].id+'-selected" value="'+g+'" /><div class="input-item"><img src="'+items[a].items[g]['content']+'" alt="" /></div></label><input id="'+items[a].id+'-name-'+g+'" class="hide" name="'+items[a].id+'-name-'+g+'" value="'+items[a].items[g]["name"]+'" type="text" /></div>';

              $('#item-'+items[a].id).find('.tracker-items').append(sub_content);
            });
        }


        //if type text
        if(items[a].type_tracker == 'text') {

          //if true then display images in random order
          //console.log('random items');
          //console.log(items[a].random);

          random_items = items[a].random;
          if(random_items == true ) {
              items[a].items = items[a].items.sort(function() {
                    return .5 - Math.random();
              });
          }

          $.each(items[a].items, function(g, item) {
          //for(g = 0; g < items[a].items.length; g++) {
            var sub_content = '<div class="tracker-select tracker-select-'+g+' tracker-select--text" data-type="'+items[a].type_tracker+'" data-value="'+items[a].items[g]["name"]+'"><label><input type="radio" name="'+items[a].id+'-selected" value="'+g+'" /><div class="input-item"><p>'+items[a].items[g]['content']+'</p></div></label><input id="'+items[a].id+'-name-'+g+'" class="hide" name="'+items[a].id+'-name-'+g+'" value="'+items[a].items[g]["name"]+'" type="text" /></div>';
            //$('#item-'+items[a].id).parent('.page').addClass('tracker-group');
            $('#item-'+items[a].id).find('.tracker-items').append(sub_content);
          });
        }

        var start_btn = '<div class="center"><button class="btn-start mt-4">start</button></div>';
        $('#item-'+items[a].id).append(start_btn);



      }

      //if type submit
      if(items[a].type == 'submit') {
        var content = '<p>'+items[a].text+'</p></br><input id="form-submit" type="submit" value="'+items[a].btn_value +'" />';
        $('#item-'+items[a].id).append(content);
      }

      //if type next
      if(items[a].type == 'next') {
        var content = '<button class="btn-next btn-next--page">'+items[a].text+'</button>';
        $('#item-'+items[a].id).append(content);
      }

      //if is ref and not likert add next button

      if(typeof ref != "undefined") {
          if(items[a].type != 'likert' ) {
            var content = '<div><button class="btn-next">weiter</button></div>';
            $('#item-'+items[a].id).append(content);
          }
      }

      if(items[a].type == 'consideration') {
        consideration_page = true;
        var content = '<h2>'+items[a].title+'</h2>';

        if ("subtitle" in items[a]) {
          content += '<p>'+items[a].subtitle+'</p>';
        }

        if ("include_text" in items[a]) {
          consideration_include_text = items[a].include_text;
        }

        content += '<div class="consideration-options select-items"></div>';
        $('#item-'+items[a].id).append(content);
        $('#item-'+items[a].id).parent('.page').addClass('consideration-group');
      }

    }

  }); //loop through pages

  return tracker_count;
}

//parse json
function parseJSON() {
  var finish = false;

  var pages_total = 0;
  var pages_current = 0;

  //console.log(blocks);

  $.each(blocks, function(s, block_item) {

      random_pages = false;
      if(block_item.options) {
        random_pages = block_item.options.random;
      }
      if(block_item.pages) {
        var pages = block_item.pages;
        var pages_count = pages.length;
        pages_total  += pages_count;
        pages_current =  pages_total - pages_count;

        //console.log('---block_item---');
        //console.log(block_item.pages);
        //console.log(pages_count);
        //console.log(pages_current);

        //parse blocks with pages
        tracker_count = parseBlocks(pages, random_pages,pages_current);
      }

      //console.log('blocks loops finsih');

  });

  finish = true;

  var obj = {
        finish: finish,
        tracker_count: tracker_count,
    };


  return obj;
}

function slider() {
  $('.list').owlCarousel({
    loop:false,
    items: 1,
    animateOut: 'fadeOut',
    animateIn: 'fadeIn',
    smartSpeed:50,
    //itemElement: 'li',
    margin:10,
    dots: true,
    nav: false,
    center: true,
    loop: false,
    mouseDrag: false,
    touchDrag: false,
  });

  $('.owl-carousel').off('keydown.bs.carousel');

  $('.owl-carousel').find('.owl-dot').attr("disabled", "disabled");
  $('.owl-dots').find('.owl-dot').attr("aria-hidden", "true");
  $('.owl-dots').find('.owl-dot').attr("tabindex", "-1");
  $('.owl-dots').find('.active').attr("aria-hidden", "false");
  $('.owl-carousel').find('.owl-item').attr("aria-hidden", "true");
  $('.owl-carousel').find('fieldset').find('input').attr("disabled", "disabled");
  $('.owl-carousel').find('.active').attr("aria-hidden", "false");
  $('.owl-carousel').find('.active').find('fieldset').find('input').removeAttr('disabled');

  $('.list').trigger('refresh.owl.carousel');

  $('.btn-next--page').on('click', function(e){
      e.preventDefault();

      $('.owl-carousel').find('.owl-item.active').attr("aria-hidden", "true");
      $('.owl-dots').find('.owl-dot.active').attr("aria-hidden", "true");

      $('.list').trigger('next.owl.carousel');

      //if (owl.currentItem + 1 === owl.itemsAmount) {
        //alert('THE END');
      //}
      //$('.owl-carousel').find('.owl-item.active').attr("aria-hidden", "false");
      //$('.owl-dots').find('.active').attr("aria-hidden", "false");
      //$('.owl-carousel').find('.active').find('fieldset').find('input').removeAttr('disabled');
  });

  $('.owl-carousel').on('change.owl.carousel', function(e) {
      //console.log('slide changed');
      //console.log(e);
      //var page_total = e.page.count;
      //var current_page = e.property.value;
  });

}

function show_tracker() {
  var btn = $('.btn-start');

  btn.each(function(){
    var thisbtn = $(this);
    thisbtn.on('click', function(e){
      e.preventDefault();
      thisbtn.closest('.item').find('.tracker-items').removeClass('hide');
      startrecord();
      thisbtn.remove();
    })
  });
}

//next slide

function nextslide() {
  var $qslider = $('.owl-carousel');
    //$('.su-carousel').find('.active').find('fieldset').find('input').attr("disabled", "disabled");
  $('.owl-carousel').find('.owl-item.active').attr("aria-hidden", "true");
  $('.owl-dots').find('.owl-dot.active').attr("aria-hidden", "true");

   setTimeout(function() {
       $qslider.trigger('next.owl.carousel');
       $('.owl-carousel').find('.owl-item.active').attr("aria-hidden", "false");
       $('.owl-dots').find('.active').attr("aria-hidden", "false");
       $('.owl-carousel').find('.active').find('fieldset').find('input').removeAttr('disabled');
    }, 500);
}

//change slide

function consideration_group() {
  jQuery('.consideration-group').each(function() {
      var $itemgroup = $(this).find('input[type="radio"]').attr('name');
      //console.log($itemgroup);

      $('[name="'+ $itemgroup + '"]').change(function() {
        if ($(this).is(':checked')) {
          nextslide();
        }
      });
  });
}

function nextq() {

  jQuery('.tracker-group').each(function() {
      var $itemgroup = $(this).find('input[type="radio"]').attr('name');

      $('[name="'+ $itemgroup + '"]').change(function() {

        if ($(this).is(':checked')) {
           // Do something...
           stoprecording();
           //console.log('stop');
           //console.log(xpos);
           //console.log(ypos);

           var item = $(this).closest('.item');
           var item_id = item.attr('id');
           var input_fields = [];

           if(consideration_page == true) {
             var selected = $(this).closest('.tracker-select');
             var selected_type = selected.attr('data-type');
             var selected_name = selected.attr('data-value');
             var selected_img = selected.attr('data-img');

              //console.log(selected_name);
              //console.log(selected_img);
              //console.log(selected_type);

              if(selected_type == 'text' && consideration_include_text == true) {
                var selected_value = '<p>'+selected_name+'</p>';
                var option = '<div class="tracker-select tracker-select--'+selected_type+'" data-value="'+selected_name+'"><label><input type="radio" name="item-consideration" value="'+selected_name+'" /><div class="input-item">'+selected_value+'</div></label></div>';
                $('[data-type="consideration"]').find('.consideration-options').append(option);
              }

              if(selected_type == 'image') {
                if(selected_img != undefined || selected_img != null) {
                  var selected_value = '<img src="'+selected_img+'" alt="" />';
                  var option = '<div class="tracker-select tracker-select--'+selected_type+'" data-value="'+selected_name+'"><label><input type="radio" name="item-consideration" value="'+selected_name+'" /><div class="input-item">'+selected_value+'</div></label></div>';
                  $('[data-type="consideration"]').find('.consideration-options').append(option);
                }
              }

             //console.log(selected_value);

             consideration_group();
           }

           item.addClass('disabled');

           item.find('input[type=text]').each(function(){
             var this_id = $(this).attr('id');
             input_fields.push(this_id);
           });

           //console.log(input_fields);

           //$('#'+input_id).val(xpos);
           $('#'+item_id+'-xpos').val(xpos);
           $('#'+item_id+'-ypos').val(ypos);

           if($('#'+item_id).next('.item').length) {
               var nextq = $('#'+item_id).parent().find('.ref');
               nextq.first().removeClass('hide').addClass('show');
               //console.log('Number of Siblings:');
               //console.log(nextq.length);
               nextq.each(function(){
                 var thisitem = $(this);

                 if($(this).has('.likert')) {
                   thisitem.find('input[type=radio]').change(function(){
                     if(thisitem.closest('.item').next('.ref').length) {
                       thisitem.closest('.item').removeClass('show').addClass('hide');
                       thisitem.closest('.item').next('.ref').removeClass('hide').addClass('show');
                     } else {
                       nextslide();
                     }
                   });
                 }

                 if($(this).not('.likert')) {
                    thisitem.find('.btn-next').on('click', function(e){
                      e.preventDefault();
                      if(thisitem.closest('.item').next('.ref').length) {
                        thisitem.closest('.item').removeClass('show').addClass('hide');
                        thisitem.closest('.item').next('.ref').removeClass('hide').addClass('show');
                      } else {
                        nextslide();
                      }
                    });
                 }

               });
           } else {

             //next slide
             nextslide();
              //alert('You can rock now...');

           }
        };
      });
  });

  // $('input').change(function() {
  // var check = $('.page').map(function(e) {
  //   return $(this).find('input[type="radio"]').is(':checked');
  // }).get()
  //
  //   //console.log(check.every(e => e == true));
  //
  //   if(check.every(e => e == true)) {
  //     //console.log('save now');
  //     save_form();
  //     $('#form-submit').trigger('submit');
  //     //document.getElementById("myBtn").click();
  //     //window.location.href = "https://vielen-dank/";
  //   }
  // });

}

//download file

function download(filename, text) {
  var dlb = document.createElement('a');
  dlb.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
  dlb.setAttribute('download', filename);

  dlb.style.display = 'none';
  document.body.appendChild(dlb);

  dlb.click();

  document.body.removeChild(dlb);
}


// save form
function save_form(finish) {
  jQuery('#'+form_id).submit(function(event){ // use jQuery no conflict methods replace $ with "jQuery"
    event.preventDefault(); // stop post action
    var formData = jQuery('#'+form_id).serializeArray();

    //output data
    //console.log(formData);

    //console.group('---tracker_count---');
    //console.log(finish.tracker_count);
    //console.log(maxcount);
    //console.groupEnd();

    //create arrays

    var tracker_item = [];
    var tracker_item_name = '';
    var tracker_items_all = [];
    var tracker_items = [];

    var tracker_header = [];
    var tracker_content = [];
    //var tracker_count = 0;

    var list_header = [];
    var list_content = [];

    //add mandatory survey fields
    list_header.push('UID');
    list_content.push(UIDrandom);

    list_header.push('TrialID');
    list_content.push(TrialID);

    list_header.push('execution-date');
    list_content.push(CurrentDateFormat);


    //loop through formData items
    for (var h = 0; h < formData.length; h++){
          var name = formData[h].name;
          var value = formData[h].value;

          //all but tracker
          if (name.toLowerCase().indexOf("tracker") < 0) {
            value = value.replace(/,/g, ".")
            list_header.push(name);
            list_content.push(value);
          }

          //all tracker items
          if (name.toLowerCase().includes("tracker") === true) {
              tracker_items_all.push(formData[h]);
          }

    } //loop formData items


    //all tracker names
    for (var i = 1; i <= parseInt(finish.tracker_count) ; i++){

        tracker_item_name = "tracker"+i;
        var tracker_item_content = {};
        tracker_item_content['id'] = tracker_item_name;

        for (var h = 0; h < tracker_items_all.length; h++){

          var name = tracker_items_all[h].name;
          var value = tracker_items_all[h].value;

          if (name.toLowerCase().indexOf(tracker_item_name) >= 0) {
            if(name.toLowerCase().indexOf("position") >= 0) {
              tracker_item_content['position'] = value;
            }
            else if(name.toLowerCase().indexOf("desc") >= 0) {
              tracker_item_content['desc'] = value;
            }
            else if (name.toLowerCase().indexOf("xpos") >= 0) {

              var list_time = [];

              var list_x = value.slice(0,-1);
                  list_x = list_x.split(",");

              var list_x_length = parseInt(list_x.length);

              if(list_x_length < maxcount ) {
                for (var j = list_x_length; j < maxcount; j++){
                  list_x.push(" ");
                }
              }

                list_x = list_x.toString();

                //build time array
                for (var k = 1; k <= list_x_length; k++){
                  list_time.push(k*period);
                }

                var list_time_length = parseInt(list_time.length);

                if(list_time_length < maxcount ) {
                  for (var l = list_time_length; l < maxcount; l++){
                    list_time.push(" ");
                  }
                }

                list_time = list_time.toString();

              tracker_item_content['xpos'] = list_x;
              tracker_item_content['time'] = list_time;
            }
            else if (name.toLowerCase().indexOf("ypos") >= 0) {

              var list_y = value.slice(0,-1);
                  list_y = list_y.split(",");

              var list_y_length = parseInt(list_y.length);

              if(parseInt(list_y_length) < maxcount ) {
                for (var j = parseInt(list_y_length); j < maxcount; j++){
                  list_y.push(" ");
                }
              }

              list_y = list_y.toString();

              tracker_item_content['ypos'] = list_y;
            }

            else if (name.toLowerCase().indexOf("selected") >= 0) {
              tracker_item_content['selected'] = value;
            }

            else if (name.toLowerCase().indexOf("-name-0") >= 0) {
              tracker_item_content['options_left'] = value;
            }

            else if (name.toLowerCase().indexOf("-name-1") >= 0) {
              tracker_item_content['options_right'] = value;
            }

            else {
              //tracker_item_content[name] = value;
              value = value.replace(/,/g, ".")
              list_header.push(name);
              list_content.push(value);
            }
          }

        }

        tracker_item.push(tracker_item_content);


    }

    //sort tracker
    for (var i = 1; i <= finish.tracker_count; i++){

        tracker_item_name = "tracker"+i;

        var marvel = tracker_item.filter(function(el) {

            return el.id === tracker_item_name;
        });

        tracker_items.push(marvel);
    }

    //get values for each tracker
    var tracker_rows = [];
    for (var i = 0; i < tracker_items.length; i++){

        var tracker_row = {};
        var sorted_row_sorted = [];
        //console.log(tracker_items[i]);
        $.each( tracker_items[i], function( key, value ) {
          $.each( value, function( k, v ) {
            tracker_row[k] = v;
          });
        });

        sorted_row = sortObject(tracker_row);

        $.each(sorted_row, function(key, value) {
          sorted_row_sorted.push(value);
        });
        tracker_rows.push(sorted_row_sorted);

      // if(tracker_selected == 0) {
      //   tracker_selected_item.push(tracker_option_left[i]);
      // } else {
      //   tracker_selected_item.push(tracker_option_right[i]);
      // }
    }


    //build teh tracker header
    $.each(sorted_row, function(key, value) {
      //console.log('---sorted keyy ---');
      //console.log(key);
      if(key != 'xpos' && key != 'ypos' && key != 'time') {
        tracker_header.push(key);
      }
    });


    tracker_header = tracker_header.toString()+',';
    list_header = list_header.toString()+',';
    list_content = list_content.toString()+',';


    //push tracker rows to content
    for (var i = 0; i < tracker_rows.length; i++){
        var tracker_rows_string = tracker_rows[i].toString();
        //tracker_content += tracker_rows_string + ','+(i+1)+','+UIDrandom+','+list_content+"\n";
        tracker_content += tracker_rows_string +','+list_content+"\n";
    }



    //Outout Data to file
    var header = "";
    var content = "";

    //push data to header

    //create header
    header += tracker_header;

    for (var i = 1; i <= maxcount; i++){
      header += "T_"+i+",";
    }

    for (var i = 1; i <= maxcount; i++){
      header += "X_"+i+",";
    }
    for (var i = 1; i <= maxcount; i++){
      header += "Y_"+i+",";
    }
    //header += "TrialID,UserID,";
    header += list_header;

    //console.log('----header----');
    //console.log(header);

    //push data to content
    content += tracker_content;

    //build file content
    var file_content = header+"\n"+content;

    console.group('formdata output');
    console.log(file_content);
    console.groupEnd();

    var filename = ''+FilenamePrefix+'-'+UIDrandom+'-'+CurrentDateMil+'';
    download(filename, file_content);

  });
}

$( document ).ready(function() {
    var finish = parseJSON();
    if(finish.finish == true) {
      slider();
      nextq();
      show_tracker();
      save_form(finish);
    }
});
